# Soma dos elementos de uma lista
def soma_rec(l, n):
    """ Soma os n primeiros elementos da lista l."""
    if n == 0:
        return 0
    else:
        return soma_rec(l, n - 1) + l[n - 1]


def soma(l):
    return soma_rec(l, len(l))

# Máximo de uma lista
def maximo_rec(l, n):
    if n == 1:
        return l[0]
    else:
        maximo_pref = maximo_rec(l, n - 1)
        if maximo_pref > l[n - 1]:
            return maximo_pref
        else:
            return l[n - 1]


def maximo(l):
    return maximo_rec(l, len(l))


# Busca sequencial em lista
def busca_rec(l, n, x):
    if n == 0:
        return None
    if l[n - 1] == x:
        return n - 1
    return busca_rec(l, n - 1, x)


def busca(l, x):
    return busca_rec(l, len(l), x)


# Inverte uma lista 
def inverte_rec(l, n, invertida):
    if n > 0:
        invertida.append(l[n - 1])
        inverte_rec(l, n - 1, invertida)


def inverte(l):
    invertida = []
    inverte_rec(l, len(l), invertida)
    return invertida


# verifica se duas listas são iguais
def iguais_rec(l1, l2, n):
    if n == 0:
        return True
    elif l1[n - 1] != l2[n - 1]:
        return False
    else:
        return iguais_rec(l1, l2, n - 1)


def iguais(l1, l2):
    if len(l1) != len(l2):
        return False
    return iguais_rec(l1, l2, len(l1))
