# Calcula todas a permutações de 1 a n
def permutacoes_rec(mem, n):
    if len(mem) == n:
        print(''.join(mem))
    else:
        for x in range(1, n + 1):
            if str(x) not in mem:
                mem.append(str(x))
                permutacoes_rec(mem, n)
                mem.pop()


def permutacoes(n):
    permutacoes_rec([], n)


# Calcula todas as combinações de tamanho r de elementos de uma lista
def combinacoes_rec(lista, r, mem):
    if len(mem) == r:
        print([lista[i] for i in mem])
    else:
        for x in range(len(lista)):
            if len(mem) == 0 or x > mem[-1]:
                mem.append(x)
                combinacoes_rec(lista, r, mem)
                mem.pop()


def combinacoes(lista, r):
    combinacoes_rec(lista, r, [])


# Verifica se uma string é uma palindromo
def palindromo_rec(palavra, e, d):
    if e >= d:
        return True
    return palindromo_rec(palavra, e + 1, d - 1) and palavra[e] == palavra[d]


def palindromo(palavra):
    return palindromo_rec(palavra, 0, len(palavra) - 1)


# Verifica se duas listas são iguais mesmo se existirem listas dentro delas
def listas_iguais_rec(lista1, lista2, n):
    if n == 0:
        return True
    if isinstance(lista1[n - 1], list) and not isinstance(lista2[n - 1], list):
        return False
    if not isinstance(lista1[n - 1], list) and isinstance(lista2[n - 1], list):
        return False
    if not isinstance(lista1[n - 1], list) and not isinstance(lista2[n - 1], list):
        return lista1[n - 1] == lista2[n - 1] and listas_iguais_rec(lista1, lista2, n - 1)
    return listas_iguais(lista1[n - 1], lista2[n - 1])


def listas_iguais(lista1, lista2):
    if len(lista1) != len(lista2):
        return False
    return listas_iguais_rec(lista1, lista2, len(lista1))
